



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>【Python之路】第四篇--Python基础之函数</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">【Python之路】第四篇--Python基础之函数</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-06 12:43:06 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<h1>三元运算</h1>
<p>三元运算（三目运算），是对简单的条件语句的缩写</p>
<div>
<pre class="prettyprint linenums"># 书写格式

result = 值1 if 条件 else 值2

# 如果条件成立，那么将 &ldquo;值1&rdquo; 赋值给result变量，否则，将&ldquo;值2&rdquo;赋值给result变量</pre>
</div>
<h1>基本数据类型补充</h1>
<p><strong>set</strong></p>
<p>set集合，是一个无序且不重复的元素集合，它的主要作用如下：</p>
<ul><li><p>去重，把一个列表变成集合，就自动去重了</p></li>
<li><p>关系测试，测试两组数据之前的交集、差集、并集等关系</p></li></ul>
<p>集合对象是一组无序排列的可哈希的值：集合成员可以做字典的键</p>
<p><strong>集合分类</strong>：可变集合、不可变集合</p>
<p>可变集合(set)：可添加和删除元素，非可哈希的，不能用作字典的键，也不能做其他集合的元素</p>
<p>不可变集合(frozenset)：与上面恰恰相反</p>
<div>
<div>
<pre class="prettyprint linenums">class set(object):<br />
    """<br />
    set() -&gt; new empty set object<br />
    set(iterable) -&gt; new set object

    Build an unordered collection of unique elements.<br />
    """<br />
    def add(self, *args, **kwargs): # real signature unknown<br />
        """<br />
        Add an element to a set，添加元素<br />
        This has no effect if the element is already present.<br />
        """<br />
        pass

    def clear(self, *args, **kwargs): # real signature unknown<br />
        """ Remove all elements from this set. 清除内容"""<br />
        pass

    def copy(self, *args, **kwargs): # real signature unknown<br />
        """ Return a shallow copy of a set. 浅拷贝  """<br />
        pass

    def difference(self, *args, **kwargs): # real signature unknown<br />
        """<br />
        Return the difference of two or more sets as a new set. A中存在，B中不存在 ( in A not in B )<br />
        (i.e. all elements that are in this set but not the others.)<br />
        """<br />
        pass

    def difference_update(self, *args, **kwargs): # real signature unknown<br />
        """ Remove all elements of another set from this set.  从当前集合中删除和B中相同的元素"""<br />
        pass

    def discard(self, *args, **kwargs): # real signature unknown<br />
        """<br />
        Remove an element from a set if it is a member.

        If the element is not a member, do nothing. 移除指定元素，不存在不保错<br />
        """<br />
        pass

    def intersection(self, *args, **kwargs): # real signature unknown<br />
        """<br />
        Return the intersection of two sets as a new set. 交集

        (i.e. all elements that are in both sets.)<br />
        """<br />
        pass

    def intersection_update(self, *args, **kwargs): # real signature unknown<br />
        """ Update a set with the intersection of itself and another.  取交集并更更新到A中 """<br />
        pass

    def isdisjoint(self, *args, **kwargs): # real signature unknown<br />
        """ Return True if two sets have a null intersection.  如果没有交集，返回True，否则返回False"""<br />
        pass

    def issubset(self, *args, **kwargs): # real signature unknown<br />
        """ Report whether another set contains this set.  是否是子序列"""<br />
        pass

    def issuperset(self, *args, **kwargs): # real signature unknown<br />
        """ Report whether this set contains another set. 是否是父序列"""<br />
        pass

    def pop(self, *args, **kwargs): # real signature unknown<br />
        """<br />
        Remove and return an arbitrary set element.<br />
        Raises KeyError if the set is empty. 移除元素<br />
        """<br />
        pass

    def remove(self, *args, **kwargs): # real signature unknown<br />
        """<br />
        Remove an element from a set; it must be a member.

        If the element is not a member, raise a KeyError. 移除指定元素，不存在保错<br />
        """<br />
        pass

    def symmetric_difference(self, *args, **kwargs): # real signature unknown<br />
        """<br />
        Return the symmetric difference of two sets as a new set.  对称差集   (not in a and b )

        (i.e. all elements that are in exactly one of the sets.)<br />
        """<br />
        pass

    def symmetric_difference_update(self, *args, **kwargs): # real signature unknown<br />
        """ Update a set with the symmetric difference of itself and another. 对称差集，并更新到a中 """<br />
        pass

    def union(self, *args, **kwargs): # real signature unknown<br />
        """<br />
        Return the union of sets as a new set.    并集<br />
        (i.e. all elements that are in either set.)<br />
        """<br />
        pass

    def update(self, *args, **kwargs): # real signature unknown<br />
        """ Update a set with the union of itself and others. 更新 """<br />
        pass</pre>
</div>
<p>set</p></div>
<p><strong>练习：</strong>寻找差异</p>
<div>
<pre class="prettyprint linenums">old_dict = {<br />
    "#1":11,<br />
    "#2":22,<br />
    "#3":100,<br />
}

new_dict = {<br />
    "#1":33,<br />
    "#4":22,<br />
    "#7":100,<br />
}

old_set = set(old_dict.keys())<br />
new_set = set(new_dict.keys())

same_set = old_set.intersection(new_set)<br />
up_set = new_set.difference(old_set)

ret_dict = {}<br />
for k in same_set:<br />
    ret_dict[k]=new_dict[k]

for i in up_set:<br />
    ret_dict[i]=new_dict[i]

print(ret_dict)<br />
# print(old_set)<br />
# print(new_set)
</pre>
</div>
<h1>深浅拷贝</h1>
<h3><strong>一、数字和字符串</strong></h3>
<p>对于 数字 和 字符串 而言，赋值、浅拷贝和深拷贝无意义，因为其永远指向同一个内存地址。</p>
<div>
<pre class="prettyprint linenums">import copy

a = 132<br />
b = 'Ales'

# ## 浅拷贝 ##<br />
aa = copy.copy(a)<br />
bb = copy.copy(b)

# ## 深拷贝 ##<br />
aaa = copy.deepcopy(a)<br />
bbb = copy.deepcopy(b)

print(id(a),id(aa),id(aaa))<br />
print(id(b),id(bb),id(bbb))

# ## 1691783456   1691783456     1691783456<br />
# ##  47227376    47227376       47227376</pre>
</div>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/425762/201601/425762-20160115223330382-1298317428.png" /></p>
<h3><strong>二、其他基本数据类型</strong></h3>
<p>对于字典、元祖、列表 而言，进行赋值、浅拷贝和深拷贝时，其内存地址的变化是不同的。</p>
<p>1、赋值</p>
<p><strong>赋值</strong>，只是创建一个变量，该变量指向原来内存地址，如：</p>
<div>
<pre class="prettyprint linenums">n1 = {"k1": "wu", "k2": 123, "k3": ["alex", 456]}

n2 = n1
</pre>
</div>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/425762/201601/425762-20160115225752366-1852942198.png" /></p>
<p>2、浅拷贝</p>
<p><strong>浅拷贝</strong>，在内存中只额外创建第一层数据</p>
<div>
<pre class="prettyprint linenums">import copy

n1 = {"k1": "wu", "k2": 123, "k3": ["alex", 456]}

n3 = copy.copy(n1)

print(id(n1),id(n3))<br />
print(id(n1["k1"]),id(n3["k1"]))

# 44947080 45383304<br />
# 45327056 45327056
</pre>
</div>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/425762/201601/425762-20160115230038772-549220231.png" /></p>
<p>3、深拷贝</p>
<p><strong>深拷贝</strong>，在内存中将所有的数据重新创建一份（排除最后一层，即：python内部对字符串和数字的优化）</p>
<div>
<pre class="prettyprint linenums">import copy

n1 = {"k1": "wu", "k2": 123, "k3": ["alex", 456]}

n4 = copy.deepcopy(n1)

print(id(n1),id(n4))<br />
print(id(n1["k3"]),id(n4["k3"]))<br />
print(id(n1["k3"][0]),id(n4["k3"][0]))

# 56088200 56460680<br />
# 58962760 58930696<br />
# 56506216 56506216
</pre>
</div>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/425762/201601/425762-20160115230309272-1357770402.png" /></p>
<h1>函数</h1>
<h3><strong>一、背景</strong></h3>
<p>在学习函数之前，一直遵循：面向过程编程，</p>
<p>即：根据业务逻辑从上到下实现功能，其往往用一长段代码来实现指定功能，开发过程中最常见的操作就是粘贴复制，也就是将之前实现的代码块复制到现需功能处，如下：</p>
<div>
<pre class="prettyprint linenums">while True：<br />
    if cpu利用率 &gt; 90%:<br />
        #发送邮件提醒<br />
        连接邮箱服务器<br />
        发送邮件<br />
        关闭连接

    if 硬盘使用空间 &gt; 90%:<br />
        #发送邮件提醒<br />
        连接邮箱服务器<br />
        发送邮件<br />
        关闭连接

    if 内存占用 &gt; 80%:<br />
        #发送邮件提醒<br />
        连接邮箱服务器<br />
        发送邮件<br />
        关闭连接
</pre>
</div>
<p>腚眼一看上述代码，if条件语句下的内容可以被提取出来公用，如下：</p>
<div>
<pre class="prettyprint linenums">def 发送邮件(内容)<br />
    #发送邮件提醒<br />
    连接邮箱服务器<br />
    发送邮件<br />
    关闭连接

while True：

    if cpu利用率 &gt; 90%:<br />
        发送邮件('CPU报警')

    if 硬盘使用空间 &gt; 90%:<br />
        发送邮件('硬盘报警')

    if 内存占用 &gt; 80%:
</pre>
</div>
<p>对于上述的两种实现方式，第二次必然比第一次的重用性和可读性要好，其实这就是函数式编程和面向过程编程的区别：</p>
<ul><li><p><strong>函数式：将某功能代码封装到函数中，日后便无需重复编写，仅调用函数即可</strong></p></li>
<li><p><strong>面向对象：对函数进行分类和封装，让开发&ldquo;更快更好更强...&rdquo;</strong></p></li></ul>
<p>简单的例子：求一个长方形的周长和面积。</p>
<p><strong>面向过程</strong>的程序设计方式：</p>
<p>1、确定长方形周长和面积的算法。</p>
<p>2、编写两个方法（函数）分别计算长方形的周长和面积。</p>
<p>3、求周长的方法（函数）和求面积的方法（函数）需要两个参数，分别是长方形的长和宽。</p>
<p><strong>面向对象</strong>的程序设计方式：</p>
<p>1、一个长方形可以看成一个长方形对象。</p>
<p>2、一个长方形对象有两个状态（长和宽）和两个行为（求周长和求面积）。</p>
<p>3、将所有长方形的共性抽取出来，设计一个长方形类。</p>
<p>4、通过长方形对象的行为，就可以求出某个具体的长方形对象的周长和面积。</p>
<h3><strong>二、函数定义和使用</strong></h3>
<div>
<pre class="prettyprint linenums">def 函数名(参数):

    ...<br />
    函数体<br />
    ...<br />
    返回值
</pre>
</div>
<p>函数的定义主要有如下要点：</p>
<ul><li>def：表示函数的关键字</li>
<li>函数名：函数的名称，日后根据函数名调用函数</li>
<li>函数体：函数中进行一系列的逻辑计算，如：发送邮件、计算出 [11,22,38,888,2]中的最大数等...</li>
<li>参数：为函数体提供数据</li>
<li>返回值：当函数执行完毕后，可以给调用者返回数据。</li></ul>
<p><strong>1、返回值</strong></p>
<p>函数是一个功能块，该功能到底执行成功与否，需要通过返回值来告知调用者。</p>
<p>返回多个对象时，封装成一个元组返回！</p>
<p>以上要点中，比较重要有参数和返回值：</p>
<div>
<pre class="prettyprint linenums">def 发送短信():<br />
    发送短信的代码...<br />
    if 发送成功:<br />
        return True<br />
    else:<br />
        return False

while True:<br />
    # 每次执行发送短信函数，都会将返回值自动赋值给result<br />
    # 之后，可以根据result来写日志，或重发等操作<br />
    result = 发送短信()<br />
    if result == False:<br />
        记录日志，短信发送失败...
</pre>
</div>
<p><strong>2、参数</strong></p>
<p>函数有三种不同的参数：</p>
<ul><li>普通参数</li>
<li>默认参数</li>
<li>动态参数</li></ul>
<div>
<div>
<pre class="prettyprint linenums"># ######### 定义函数 ######### 

# name 叫做函数func的形式参数，简称：形参<br />
def func(name):<br />
    print name

# ######### 执行函数 #########<br />
#  'alex' 叫做函数func的实际参数，简称：实参<br />
func('alex')</pre>
</div>
<p>普通参数</p></div>
<div>
<div>
<pre class="prettyprint linenums">def func(name, age = 18):

    print "%s:%s" %(name,age)

# 指定参数<br />
func('wupeiqi', 19)<br />
# 使用默认参数<br />
func('alex')

注：默认参数需要放在参数列表最后</pre>
</div>
<p>默认参数</p></div>
<div>
<div>
<pre class="prettyprint linenums">def func(*args):<br />
    print(args,type(args))

# 执行方式一<br />
func(11,33,4,4454,5,['',''])

# (11, 33, 4, 4454, 5, ['11', '22']) &lt;class 'tuple'&gt;

# 执行方式二<br />
li = [11,2,2,3,3,4,54]

func(li)<br />
# ([11, 2, 2, 3, 3, 4, 54],) &lt;class 'tuple'&gt;   注意此处!元组第一个元素为列表

func(*li)<br />
# (11, 2, 2, 3, 3, 4, 54) &lt;class 'tuple'&gt;</pre>
</div>
<p>动态参数一</p></div>
<div>
<div>
<pre class="prettyprint linenums">def func(**kwargs):<br />
    print(kwargs)

# 执行方式一<br />
func(name='wupeiqi',age=18)

# 执行方式二<br />
li = {'name':'wupeiqi', 'age':18, 'gender':'male'}<br />
func(**li)

# {'name': 'wupeiqi', 'age': 18}<br />
# {'name': 'wupeiqi', 'age': 18, 'gender': 'male'}</pre>
</div>
<p>动态参数二</p></div>
<div>
<div>
<pre class="prettyprint linenums">def f1(*a,**aa):<br />
    print(a,type(a))<br />
    print(aa,type(aa))

f1(11,22,33,k1=123,k2=456)

# (11, 22, 33) &lt;class 'tuple'&gt;<br />
# {'k1': 123, 'k2': 456} &lt;class 'dict'&gt;</pre>
</div>
<p>动态参数一,二结合</p></div>
<p><strong>3.函数名可以做参数传递</strong></p>
<p>　　函数名() &nbsp;=&gt; &nbsp;执行函数</p>
<p>　　函数名 &nbsp; &nbsp;=&gt; &nbsp;代指函数内容</p>
<div>
<pre class="prettyprint linenums">def f1():<br />
    print("F1")<br />
    return "F1"

def f2(arg):<br />
    arg()<br />
    print("F2")<br />
    return "F2"

f2(f1)

# F1<br />
# F2</pre>
</div>
<h1>函数式编程、面向过程编程、面向对象编程</h1>
<p><strong>函数式编程&nbsp;</strong>：主要思想是把运算过程尽量写成一系列嵌套的函数调用。<strong>增强代码的重用性和可读性</strong></p>
<p>传统的编程模式：</p>
<blockquote><p>　　var a = 1 + 2;</p>
<p>　　var b = a * 3;</p>
<p>　　var c = b - 4;</p></blockquote>
<p>函数式编程要求使用函数，我们可以把运算过程定义为不同的函数，然后写成下面这样：</p>
<blockquote><p>　　var result = subtract(multiply(add(1,2), 3), 4);</p></blockquote>
<p>函数式编程具有五个<strong>鲜明的特点</strong>。</p>
<p>　　（1）<strong>函数是"第一等公民"</strong>，与其他数据类型一样，处于平等地位，可以赋值给其他变量，也可以作为参数，传入另一个函数，或者作为别的函数的返回值。</p>
<p>　　（2）<strong>申明式（Declarative）的编程方式</strong>，相对于命令式而言，命令式程序设计大量使用可变对象和指令。习惯于创建对象或者变量，并且修改它们的状态或者值，或者喜欢提供一系列指令，要求程序执行。</p>
<p>　　对于申明式编程范式，不需要提供明确的指令操作，所有的细节指令将会更好的被程序库所封装，只需要提出要求，申明用意即可。</p>
<p>　　（3）<strong>无"副作用"（side effect）</strong>，指的是函数内部与外部互动（最典型的情况，就是修改全局变量的值），产生运算以外的其他结果。</p>
<p>　　显式函数指函数与外界交换数据的唯一渠道就是参数和返回值，显式函数不会去读取或者修改函数的外部状态，</p>
<p>　　隐式函数除了参数和返回值外，还会读取外部信息，或者可能修改外部信息。</p>
<p>　　（4）<strong>不修改状态</strong>，函数式编程只是返回新的值，不修改系统变量。因此，不修改变量，也是它的一个重要特点。</p>
<p>　　在其他类型的语言中，变量往往用来保存"状态"（state）。不修改变量，意味着状态不能保存在变量中。函数式编程使用参数保存状态，最好的例子就是递归。</p>
<p>　　（5）<strong>尾递归优化</strong>，尾递归操作处于函数的最后一步。这种情况下，函数的工作其实已经完成（剩余工作就是再次调用它自身）。</p>
<p>　　编译器可以进行优化，用新函数的帧栈覆盖掉老函数的帧栈，避免递归操作不断申请栈空间。</p>
<p>函数式编程<strong>好处</strong>：</p>
<p>　　（1）<strong>代码简洁，开发快速。</strong>函数式编程大量使用函数，减少了代码的重复，因此程序比较短，开发速度较快。</p>
<p>　　（2）<strong>接近自然语言，易于理解。</strong></p>
<p>　　（3）<strong>易于并发编程（concurrency）</strong>。函数式编程不需要考虑"死锁"（deadlock），因为它不修改变量，所以根本不存在"锁"线程的问题。不必担心一个线程的数据，被另一个线程修改，所以可以很放心地把工作分摊到多个线程，部署"并发编程"。</p>
<p><strong>面向过程</strong>是一种以事件为中心的编程思想，以功能（行为）为导向，面向过程类型的编码是需求的直译过程。按模块化的设计，就是分析出解决问题所需要的步骤，然后用函数把这些步骤一步一步实现，实现的时候一个一个依次调用。</p>
<p><strong>面向对象</strong>是一种以事物为中心的编程思想，以数据（属性）为导向，将具有相同一个或者多个属性的物体抽象为&ldquo;类&rdquo;，将他们包装起来；而有了这些数据(属性)之后，我们再考虑他们的行为（对这些属性进行怎样的操作），是把构成问题的事物分解成各个对象，建立对象的目的不是为了完成一个步骤，而是为了描述某个事物在整个解决问题的步骤中的行为。</p>
<h1>内置函数</h1>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/425762/201601/425762-20160115210339553-378378117.png" /></p>
<p>注：查看详细<a href="http://www.cnblogs.com/5poi/articles/6063469.html" rel="external nofollow noreferrer">猛击这里</a></p>
<p><strong>open()函数　=&gt; &nbsp;</strong><a href="http://www.cnblogs.com/5poi/articles/6066633.html" rel="external nofollow noreferrer">详情点击</a></p>
<h1>lambda表达式</h1>
<p>学习条件运算时，对于简单的 if else 语句，可以使用三元运算来表示，即：</p>
<div>
<pre class="prettyprint linenums"># 普通条件语句<br />
if 1 == 1:<br />
    name = 'eric'<br />
else:<br />
    name = 'alex'

# 三元运算<br />
name = 'eric' if 1 == 1 else 'alex'</pre>
</div>
<p>对于简单的函数，也存在一种简便的表示方式，即：lambda表达式</p>
<div>
<pre class="prettyprint linenums">func = lambda x,y : x+1
</pre>
</div>
<ul><li>参数 &nbsp;x,y</li>
<li>函数体</li>
<li>隐含 return</li>
<li>func 函数名</li></ul>
<div>
<pre class="prettyprint linenums"># ###################### 普通函数 ######################<br />
def f1(x):<br />
    return x+100

result = f1(10)<br />
print(result)

# ###################### lambda ######################

my_lambda = lambda x : x+100<br />
result = my_lambda(10)<br />
print(result)</pre>
</div>
<p><strong>注意 :</strong></p>
<div>
<pre class="prettyprint linenums">def makelist():<br />
    L = []<br />
    for i in range(5):<br />
        L.append(lambda x: i**x)<br />
    return L

mylist = makelist()

&gt;&gt;&gt; mylist[0](0)<br />
1<br />
&gt;&gt;&gt; mylist[0](1)<br />
4<br />
&gt;&gt;&gt; mylist[0](2)<br />
16</pre>
</div>
<p>i 为enclosing variables，直到lambda函数调用时，i 的最终值为4</p>
<p>具体参考python作用域</p>
<h1>for&nbsp;循环中的&nbsp;lambda 表达式</h1>
<p><strong>第一种：</strong></p>
<blockquote><p>f = [ lambda x: x*i&nbsp; for i in range(4) ]</p></blockquote>
<p>调用结果为：</p>
<div>
<pre class="prettyprint linenums">&gt;&gt;&gt; f = [lambda x:x*i for i in range(4)]<br />
&gt;&gt;&gt; f[0](1)<br />
3    # 1*3<br />
&gt;&gt;&gt; f[1](1)<br />
3    # 1*3<br />
&gt;&gt;&gt; f[2](1)<br />
3    # 1*3<br />
&gt;&gt;&gt; f[0](3)<br />
9    # 3*3<br />
&gt;&gt;&gt; f[1](3)<br />
9    # 3*3<br />
&gt;&gt;&gt; f[2](3)<br />
9    # 3*3</pre>
</div>
<p>表达式展开为函数代码：</p>
<div>
<pre class="prettyprint linenums">def func():<br />
    fs = []<br />
    for i in range(4):<br />
        def lam(x):<br />
            return x*i<br />
        fs.append(lam)<br />
    return fs

&gt;&gt;&gt; f = func()<br />
&gt;&gt;&gt; f[0](3)<br />
9<br />
&gt;&gt;&gt; f[2](3)<br />
9<br />
&gt;&gt;&gt; f[1](3)<br />
9</pre>
</div>
<p>　　当调用func()时，每次循环都将lam()函数的地址放入到fs列表中。</p>
<p>　　循环中的lam()函数，都未绑定i的值，直到循环结束，i的值为3，并将lam()函数中所用到的 i&nbsp;值定为3。</p>
<p>　　到调用时，i&nbsp;的值&nbsp;一直保持为3。</p>
<p><strong>另一种：</strong></p>
<blockquote><p>f = [ lambda :i*i for i in range(4) ]　　（没有传入x值）</p></blockquote>
<div>
<pre class="prettyprint linenums">&gt;&gt;&gt; f = [lambda :i*i for i in range(4)]<br />
&gt;&gt;&gt; f[0]()<br />
9<br />
&gt;&gt;&gt; f[1]()<br />
9<br />
&gt;&gt;&gt; f[2]()<br />
9<br />
&gt;&gt;&gt; f[3]()<br />
9 </pre>
</div>
<p><strong>第二种：</strong></p>
<blockquote><p>f = [ lambda i=i: i*i for i in range(4) ]</p></blockquote>
<p>表达式调用结果为：</p>
<div>
<pre class="prettyprint linenums">&gt;&gt;&gt; f1 = [lambda i=i: i*i for i in range(4)]<br />
&gt;&gt;&gt; f1[0]()<br />
0<br />
&gt;&gt;&gt; f1[1]()<br />
1<br />
&gt;&gt;&gt; f1[2]()<br />
4<br />
&gt;&gt;&gt; f1[3]()<br />
9</pre>
</div>
<p>展开为函数为：</p>
<div>
<pre class="prettyprint linenums">def func():<br />
    fs = []<br />
    for i in range(4)<br />
        def lam(x=i):   # 即 i=i<br />
            return x*x    # 即 i*i<br />
        fs.append(lam)<br />
    return fs</pre>
</div>
<p>　　当调用func()函数时，每次循环都将lam()函数的地址放入到fs列表中。</p>
<p>　　但是在每次循环中，都将 i 的值绑定到了 x 上，所以直到循环结束，每次的&nbsp;x&nbsp;的值都不一样。</p>
<p>　　到调用时，x&nbsp;的值为当时绑定的值。</p>
<p>　　当有给&nbsp;lam()函数&nbsp;进行参数传递时，参数就绑定到&nbsp;x&nbsp;的值上。</p>
<div>
<pre class="prettyprint linenums">&gt;&gt;&gt; f1 = [lambda i=i: i*i for i in range(4)]<br />
&gt;&gt;&gt; f1[0](8)<br />
64<br />
&gt;&gt;&gt; f1[1](8)<br />
64<br />
&gt;&gt;&gt; f1[2](8)<br />
64<br />
&gt;&gt;&gt; f1[3](8)<br />
64</pre>
</div>
<p><strong>第三种：</strong></p>
<blockquote><p>f = [ lambda x=i:i*i for i in range(4) ]</p></blockquote>
<p>表达式调用结果为：</p>
<div>
<pre class="prettyprint linenums">&gt;&gt;&gt; f2 = [lambda x=i: i*i for i in range(4)]<br />
&gt;&gt;&gt; f2[0]()<br />
9<br />
&gt;&gt;&gt; f2[1]()<br />
9<br />
&gt;&gt;&gt; f2[2]()<br />
9<br />
&gt;&gt;&gt; f2[0](1)<br />
9<br />
&gt;&gt;&gt; f2[1](2)<br />
9</pre>
</div>
<p>传不传参数都不影响结果。展开后：</p>
<div>
<pre class="prettyprint linenums">def func():<br />
    fs = []<br />
    for i in range(4)<br />
        def lam(x=i):<br />
            return i*i<br />
        fs.append(lam)<br />
    return fs</pre>
</div>
<p>　　虽然&nbsp;lam()函数 将&nbsp;i&nbsp;的值绑定到&nbsp;x上，但是函数体中并没有使用到&nbsp;x&nbsp;的值，</p>
<p>　　直到循环结束，i 的值变为3，才会在调用时使用。</p>
<h1>递归</h1>
<p>利用函数编写如下数列：</p>
<p>斐波那契数列指的是这样一个数列 0, 1, 1, 2, 3, 5, 8, 13, 21, 34, 55, 89, 144, 233，377，610，987，1597，2584，4181，6765，10946，17711，28657，46368...</p>
<p>斐波纳契数列以如下被以递归的方法定义：F(0)=0，F(1)=1，F(2)=1, F(n)=F(n-1)+F(n-2)（n&gt;=2，n&isin;N*）</p>
<div>
<pre class="prettyprint linenums">def f1(a1,a2):<br />
    if a1 == 0:<br />
        print(a1,a2)<br />
    a3 = a1 + a2<br />
    print(a3)<br />
    f1(a2,a3)

f1(0,1)</pre>
</div>
<p><strong>第一种（递归法）：</strong></p>
<p>　　写法最简洁，但是效率最低，会出现大量的重复计算，时间复杂度O（1.618^n）,而且最深度1000</p>
<div>
<pre class="prettyprint linenums">def fi(n):<br />
    if n &lt;= 1:<br />
        return n<br />
    return fi(n-2) + fi(n-1)

for i in range(6):<br />
    print(fi(i),end=' ')</pre>
</div>
<p><strong>第二种（递推法）：</strong></p>
<p>　　递推法，就是递增法，时间复杂度是 O(n)，呈线性增长，如果数据量巨大，速度会越拖越慢</p>
<div>
<pre class="prettyprint linenums">def fi(n):<br />
    if n &lt;= 1:<br />
        return n<br />
    a, b = 0, 1<br />
    for i in range(n-1):<br />
        a, b = b, a + b

    return b</pre>
</div>
<p><strong>第三种（生成器）：</strong></p>
<div>
<pre class="prettyprint linenums">def fi(n):<br />
    a, b = 0, 1<br />
    while n &gt;= 1 :<br />
        a, b = b, a+b<br />
        yield a<br />
        n -= 1

for i in fi(6):<br />
    print(i, end=' ')</pre>
</div>
<p><strong>第四种（类）：</strong></p>
<div>
<pre class="prettyprint linenums">class Fabinacci(object):<br />
    def __init__(self, count):<br />
        self.current = 0<br />
        self.a = 0<br />
        self.b = 1<br />
        self.max = count

    def __next__(self):<br />
        if self.current &lt; self.max:<br />
            self.a,self.b = self.b, self.a + self.b<br />
            self.current += 1<br />
            return self.a<br />
        else:<br />
            raise StopIteration

    def __iter__(self):<br />
        return self

for i in Fabinacci(6):<br />
    print(i, end=' ')</pre>
</div>
<p>第五种（矩阵）：</p>
<p>　　因为幂运算可以使用二分加速，所以矩阵法的时间复杂度为 O(log n)</p>
<p>　　用科学计算包numpy来实现矩阵法 O(log n)</p>
<p><img referrerpolicy="no-referrer"src="https://images2018.cnblogs.com/blog/778496/201807/778496-20180713200909560-1043089630.png" /></p>
<div>
<pre class="prettyprint linenums">### 1<br />
import numpy<br />
def fib_matrix(n):<br />
    res = pow((numpy.matrix([[1, 1], [1, 0]])), n) * numpy.matrix([[1], [0]])<br />
    return res[0][0]<br />
for i in range(10):<br />
    print(int(fib_matrix(i)), end=' ')

### 2<br />
# 使用矩阵计算斐波那契数列<br />
def Fibonacci_Matrix_tool(n):<br />
    Matrix = npmpy.matrix("1 1;1 0")<br />
    # 返回是matrix类型<br />
    return pow(Matrix, n)  # pow函数速度快于 使用双星好 **

def Fibonacci_Matrix(n):<br />
    result_list = []<br />
    for i in range(0, n):<br />
        result_list.append(numpy.array(Fibonacci_Matrix_tool(i))[0][0])<br />
    return result_list<br />
# 调用<br />
Fibonacci_Matrix(10)</pre>
</div>
<h1>练习题</h1>
<p>1、简述普通参数、指定参数、默认参数、动态参数的区别</p>
<div>
<pre class="prettyprint linenums"># 普通参数：按照形式参数的指定位置 传入参数。<br />
# 指定参数：可以在实际参数里指定任意位置,传入参数。<br />
# 默认参数：如果实际参数没有给形式参数传入值　　那么默认使用的参数就是默认参数　默认参数需要放到尾部<br />
# 动态参数：可以无限传入任意参数，如果是*代表传入参数的形式将会是元组 **表示将会是字典</pre>
</div>
<p>2、写函数，计算传入字符串中【数字】、【字母】、【空格] 以及 【其他】的个数</p>
<div>
<div>
<pre class="prettyprint linenums">#!/usr/bin/env python<br />
# -*-coding:utf-8 -*-

def counts(str):<br />
    num_counts=0<br />
    al_counts=0<br />
    space_num=0<br />
    other=0<br />
    for i in str:<br />
        if i.isdigit():<br />
            num_counts += 1<br />
        elif i.isalpha():<br />
            al_counts += 1<br />
        elif i.isspace():<br />
            space_num +=1<br />
        else:<br />
            other += 1<br />
    print(num_counts,al_counts,space_num,other)

counts('123 456abc def g_*-/')</pre>
</div>
</div>
<p>3、写函数，判断用户传入的对象（字符串、列表、元组）长度是否大于5。</p>
<div>
<div>
<pre class="prettyprint linenums">#!/usr/bin/env python<br />
# -*-coding:utf-8 -*-

def length(input):<br />
    if isinstance(input,str) or isinstance(input,list) or isinstance(input,tuple):<br />
        if len(input) &gt; 5:<br />
            print("大于5")<br />
            return True<br />
        else:<br />
            print("小于5")<br />
            return False<br />
    else:<br />
        print("类型错误!")<br />
        return None

length("abc544")

li = ['','','','asd',45,22,]<br />
length(li)

tu=(11,22,33,44,)<br />
length(tu)

a =123<br />
length(a)</pre>
</div>
</div>
<p>4、写函数，检查用户传入的对象（字符串、列表、元组）的每一个元素是否含有空内容。</p>
<div>
<div>
<pre class="prettyprint linenums">#!/usr/bin/env python<br />
# -*-coding:utf-8 -*-

def has_space(str):<br />
    ret = False<br />
    for i in str:<br />
        if i.isspace():<br />
            ret = True<br />
            break<br />
    return ret

ret = has_space('22 123')<br />
print(ret)</pre>
</div>
</div>
<p>5、写函数，检查传入列表的长度，如果大于2，那么仅保留前两个长度的内容，并将新内容返回给调用者。</p>
<div>
<div>
<pre class="prettyprint linenums">#!/usr/bin/env python<br />
# -*-coding:utf-8 -*-

def check(li):<br />
    if len(li)&gt;2:<br />
        del li[2:]

li = [11,22,33,44,55]<br />
check(li)<br />
print(li)</pre>
</div>
</div>
<p>6、写函数，检查获取传入列表或元组对象的所有奇数位索引对应的元素，并将其作为新列表返回给调用者。</p>
<div>
<div>
<pre class="prettyprint linenums">#!/usr/bin/env python<br />
# -*-coding:utf-8 -*-

def check(li):<br />
    return li[0:len(li):2]

li = [11,22,33,44,55,66,77,88,99]<br />
ll = check(li)<br />
print(ll)</pre>
</div>
</div>
<p>7、写函数，检查传入字典的每一个value的长度,如果大于2，那么仅保留前两个长度的内容，并将新内容返回给调用者。</p>
<div>
<pre class="prettyprint linenums">dic = {"k1": "v1v1", "k2": [11,22,33,44]}

PS:字典中的value只能是字符串或列表</pre>
</div>
<div>
<div>
<pre class="prettyprint linenums">#!/usr/bin/env python<br />
# -*-coding:utf-8 -*-

dic = {"k1": "v1v1", "k2": [11,22,33,44],"k3":''}

def check(dic):<br />
    for k,v in dic.items():<br />
        if len(v)&gt;2:<br />
            dic[k]=v[0:2]<br />
    return dic

check(dic)<br />
print(dic)</pre>
</div>
</div>
<p>8、写函数，利用递归获取斐波那契数列中的第 10 个数，并将该值返回给调用者。</p>
<div>
<div>
<pre class="prettyprint linenums">#!/usr/bin/env python<br />
# -*-coding:utf-8 -*-

def f1(a1,a2,depth):<br />
    if depth == 10:<br />
        return a1<br />
    a3 = a1 + a2<br />
    a1 = f1(a2,a3,depth+1)<br />
    return a1

a = f1(0,1,1)<br />
print(a)</pre>
</div>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/5qyo24j8.html">OSGI&period;NET 框架浅析</a>
		</li>
						<li><a href="https://www.batexi.com/a/1q24e3v8.html">调用 webapi的put和delete 报&amp;quot&semi;Method Not Allowed&amp;quot&semi;   405  错误。</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e1xg6z9.html">MEF学习笔记</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4y24xjq.html">UVA 10739 String to Palindrome（动态规划 回文）</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7m621gq.html">各硬件装置在 Linux 中的文件名（笔记）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qn130n28.html">JavaEE Tutorials &lpar;21&rpar; - Java EE安全：高级主题</a>
		</li>
						<li><a href="https://www.batexi.com/a/8z1mp5x9.html">怎样在小方框上打对号 小方框内打对勾 word 方框打对勾</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvvx6ooq.html">Android   GridView&lpar;九宫图&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qydejp2q.html">Objective-c  字典对象</a>
		</li>
						<li><a href="https://www.batexi.com/a/90mv5km8.html">真实世界里的钢铁侠－特斯拉汽车创始人埃隆&amp;amp&semi;&num;183&semi;马斯克（Elon Musk）</a>
		</li>
						<li><a href="https://www.batexi.com/a/950pjrz8.html">Android面试题集锦 &lpar;转&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwj4g1y8.html">bootstrap --&amp;gt&semi;  reset  css</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxkr4508.html">从VGA到GPU！细数二十年显卡发展历程</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zomoddq.html">10-JavaScript之DOM的事件操作</a>
		</li>
						<li><a href="https://www.batexi.com/a/95gxkreq.html">Ignite&lpar;三&rpar;&colon; Ignite VS Spark</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j1m25l9.html">在CentOS上配置SAMBA共享目录&lpar;转载&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7odrnx8.html">ORA-600 &lbrack;kcblin&lowbar;3&rsqb; 解决方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/9r5lrymq.html">误删除innodb ibdata数据文件</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2517gwq.html">js关卡函数，throat函数实现，定时运行函数</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyyzeogq.html">mongodb学习-练习实例</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qwjv6dr8.html">jquery跨域请求数据</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gejll48.html">php memcached&plus;Mysql&lpar;主从&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/qv1e53oq.html">spring mvc页面显示图片失败</a>
			</li>
						<li><a href="https://www.batexi.com/a/96p3j6n8.html">一口一口吃掉Hexo（一）</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxk2dgd8.html">php bin&sol;console doctrine&colon;migrations&colon;migrate</a>
			</li>
						<li><a href="https://www.batexi.com/a/8zokkgvq.html">grunt--自动化打包工具使用</a>
			</li>
						<li><a href="https://www.batexi.com/a/8kpoo559.html">自己找到的一些比较实用比较好看的前端特效。很多是前面提供的jquery网站的</a>
			</li>
						<li><a href="https://www.batexi.com/a/qlj1o409.html">console&period;dir&lpar;&rpar;和console&period;log&lpar;&rpar;的区别</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdpjdpvq.html">Hive插数据报错</a>
			</li>
						<li><a href="https://www.batexi.com/a/8kpong69.html">Bucket Sort - leetcode &lbrack;桶排序&rsqb;</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
